Crypto++ 8.6 Free C++ class library of cryptographic schemes

Public Member Functions | Static Public Member Functions | List of all members
Whirlpool Class Reference

Whirlpool message digest. More...

Inheritance diagram for Whirlpool:

## Public Member Functions
std::string | AlgorithmProvider () const
| The Whirlpool hashing function. More...
void | TruncatedFinal (byte *hash, size_t size)
Public Member Functions inherited from IteratedHashWithStaticTransform< word64, BigEndian, 64, 64, Whirlpool >
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
Public Member Functions inherited from ClonableImpl< DERIVED, BASE >
Clonable * | Clone () const
| Create a copy of this object. More...

## Static Public Member Functions
static const char * | StaticAlgorithmName ()
static void | InitState (HashWordType *state)
static void | Transform (word64 *digest, const word64 *data)

## Additional Inherited Members
Static Public Attributes inherited from IteratedHashWithStaticTransform< word64, BigEndian, 64, 64, Whirlpool >
static const int | DIGESTSIZE

## Detailed Description

Whirlpool message digest.

Crypto++ provides version 3.0 of the Whirlpool algorithm. This version of the algorithm was submitted for ISO standardization.

Since
  Crypto++ 5.2

See also
  Whirlpool

Definition at line 29 of file whrlpool.h.

## Member Function Documentation

## ◆ AlgorithmProvider()

std::string Whirlpool::AlgorithmProvider | ( |  | ) | const

The Whirlpool hashing function.

References

The Whirlpool algorithm was developed by Paulo S. L. M. Barreto and Vincent Rijmen.

See P.S.L.M. Barreto, V. Rijmen, ``The Whirlpool hashing function,'' NESSIE submission, 2000 (tweaked version, 2001), https://www.cosic.esat.kuleuven.ac.be/nessie/workshop/submissions/whirlpool.zip

Author
  Paulo S.L.M. Barreto
  Vincent Rijmen.

Version
  3.0 (2003.03.12)

=============================================================================

Differences from version 2.1:

- Suboptimal diffusion matrix replaced by cir(1, 1, 4, 1, 8, 5, 2, 9).

=============================================================================

Differences from version 2.0:

- Generation of ISO/IEC 10118-3 test vectors.
- Bug fix: nonzero carry was ignored when tallying the data length (this bug apparently only manifested itself when feeding data in pieces rather than in a single chunk at once).
- Support for MS Visual C++ 64-bit integer arithmetic.

Differences from version 1.0:

- Original S-box replaced by the tweaked, hardware-efficient version.

=============================================================================

THIS SOFTWARE IS PROVIDED BY THE AUTHORS ''AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Definition at line 92 of file whrlpool.cpp.

The documentation for this class was generated from the following files:

- whrlpool.h
- whrlpool.cpp